package com.ruoyi.app.controller;

import com.ruoyi.app.annotation.LoginAppUser;
import com.ruoyi.app.controller.base.AppBaseController;
import com.ruoyi.app.domain.TbAppUser;
import com.ruoyi.app.domain.TbPublishComment;
import com.ruoyi.app.domain.vo.AppMemberVo;
import com.ruoyi.app.service.ITbPublishCommentService;
import com.ruoyi.common.core.domain.AjaxResult;
import com.ruoyi.common.utils.StringUtils;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.RequiredArgsConstructor;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.Date;

/**
 * 评论
 *
 * @author Alex
 * @date 2020-10-09
 */
@Api(value = "评论管理",tags = "评论管理")
@RequiredArgsConstructor(onConstructor_ = @Autowired)
@RestController
@RequestMapping("/app/comment" )
public class PublishCommentController extends AppBaseController {

    private final ITbPublishCommentService commentService;

    /**
     * 添加评论
     * @param comment
     * @return
     */
    @ApiOperation("添加评论")
    @GetMapping("/add")
    public AjaxResult addComment(TbPublishComment comment) {
        if (comment.getPublishId() == null || comment.getAppUserId() == null) {
            return AjaxResult.error("参数为空");
        }
        if (StringUtils.isBlank(comment.getContents())){
            return AjaxResult.error("评论内容不能为空");
        }
        AppMemberVo user = getLoginUser().getUser();
        comment.setCreateBy(user.getUserId().toString());
        comment.setCreateTime(new Date());
        if (commentService.save(comment)){
            return AjaxResult.success("评论成功");
        }
        return AjaxResult.error("评论失败");
    }
}
